spec:
  inputs:
    stage:
      default: validate
    docker_hub_host:
      default: docker.io
---
include:
  - local: 'internal/go/caching.yml'

go_mod_tidy:
  image: $[[ inputs.docker_hub_host ]]/golang:${GL_ASDF_GOLANG_VERSION}
  stage: $[[ inputs.stage ]]
  needs: []
  extends:
    - .go-mod-cache
  script:
    - |
      mkdir -p "${GOMODCACHE}"
      echo "Cache size at start:"
      du -h -d0 "${GOMODCACHE}"

    - GO_MOD_VERSION=$(grep "^go " go.mod |awk '{print $2}')
    - if [ "${GO_MOD_VERSION}" == "1.16" ] || [ "${GO_MOD_VERSION}" == "1.17" ]; then
        GO_MOD_COMPAT_FLAG=-compat=1.17
      ; else
        GO_MOD_COMPAT_FLAG=
      ; fi
    - go mod tidy $GO_MOD_COMPAT_FLAG
    - git diff --exit-code || {
        echo "running 'go mod tidy $GO_MOD_COMPAT_FLAG' produced changes.";
        echo "please run 'go mod tidy $GO_MOD_COMPAT_FLAG' and commit the changes.";
        echo "For more information, visit https://gitlab.com/gitlab-com/gl-infra/common-ci-tasks/blob/main/go-mod-tidy.md";
        exit 1;
      }
  after_script: |
    cat <<-EOD
    ----------------------------------------------------------
    Need help? Documentation on the go_mod_tidy CI job can be found at:
    https://gitlab.com/gitlab-com/gl-infra/common-ci-tasks/-/blob/main/go-mod-tidy.md
    EOD
  rules:
    - if: '$CI_PIPELINE_SOURCE == "merge_request_event"'
    - if: '$CI_PIPELINE_SOURCE == "merge_request_event" || ($CI_COMMIT_BRANCH == $CI_DEFAULT_BRANCH && $CI_PIPELINE_SOURCE != "schedule")'

  # Automatically retry on any system blips
  retry:
    max: 2
    when:
      - runner_system_failure
